﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using ZedGraph;

namespace netvis
{
     partial class GUI : Form
    {
        protected Network model;
        public GUI()
        {
            InitializeComponent();
            this.Text = "Network Traffic";
            paser1ToolStripMenuItem.Checked = true;
            zedGraphControl1.GraphPane.XAxis.Title = new AxisLabel("Time", "Times New Roman", 20, Color.Black, false, false, false);
            zedGraphControl1.GraphPane.YAxis.Title = new AxisLabel("Number Of packets", "Times New Roman", 20, Color.Black, false, false, false);
            zedGraphControl1.GraphPane.XAxis.Scale.FormatAuto = false;
            zedGraphControl1.GraphPane.XAxis.Type = AxisType.Date;
            zedGraphControl1.GraphPane.XAxis.Scale.Format = "G";
            zedGraphControl1.GraphPane.XAxis.Scale.MagAuto = false;
            model = Network.instance(this);
            this.button2.Visible = false;
            comboBox2.SelectedIndex = 0;
        }

        private void openToolStripMenuItem_Click(object sender, EventArgs e)
        {
            model.open();
            foreach (NetworkInterface inter in model.getAllInterfaces())
            {
                comboBox1.Items.Add(inter);
            }
            comboBox1.SelectedIndex = 0;
            label1.Text = "Total Packets Allowed: " + model.getTotalPass();
            label2.Text = "Total Packets Blocked: " + model.getTotalBlock();
            label3.Text = "Between " + model.getStartTime() + " and " + model.getEndTime();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            packetListView.Items.Clear();
            //packetListView.Items.AddRange(((NetworkInterface)comboBox1.SelectedItem).getAllPackets());
            foreach (Packet s in ((NetworkInterface)comboBox1.SelectedItem).getAllPackets())
            {
                ListViewItem t = new ListViewItem(new string[] { s.ToString() });
                t.Tag = s;
                packetListView.Items.Add(t);

            }
        }

        private void button1_Click(object sender, EventArgs e)
        {
            model.updateGraph(((NetworkInterface)comboBox1.SelectedItem));
        }

        private void paser1ToolStripMenuItem_Click(object sender, EventArgs e)
        {
            paser1ToolStripMenuItem.Checked = !paser1ToolStripMenuItem.Checked;
        }

        private void button2_Click(object sender, EventArgs e)
        {

        }

        public void addLineToGraph(PointPairList points, Color color, String name)
        {
            points.Sort();
            LineItem line = this.zedGraphControl1.GraphPane.AddCurve(name, points, color, SymbolType.None);
            line.Line.Width = 2;
            line.Line.Fill = new Fill(color);
            line.GetXAxis(zedGraphControl1.GraphPane).Scale.MagAuto = false;
            zedGraphControl1.GraphPane.AxisChange();
            zedGraphControl1.Refresh();
            zedGraphControl1.GraphPane.CurveList[zedGraphControl1.GraphPane.CurveList.Count - 1].Tag = line;
        }
        public void updateGraph(PointPairList change) {
            zedGraphControl1.GraphPane.CurveList[zedGraphControl1.GraphPane.CurveList.Count - 1].Points = change;
            zedGraphControl1.GraphPane.AxisChange();
            zedGraphControl1.Refresh();
        }
        public void updateCurveItem(String name, PointPairList data)
        {
            CurveItem toUpdate = null;
            foreach (CurveItem cl in zedGraphControl1.GraphPane.CurveList)
            {
                if (cl.Label.Text.Equals(name))
                {
                    toUpdate = cl;
                }
            }

            if (toUpdate != null)
            {

                if (toUpdate.Points.Count == 0)
                {
                    data.Sort();
                    toUpdate.Points = data;
                }
                else
                {
                    toUpdate.Points = new PointPairList();
                }

            }
            zedGraphControl1.GraphPane.AxisChange();
            zedGraphControl1.Refresh();
        }

        private void button2_Click_1(object sender, EventArgs e)
        {
           // model.readMore();
            comboBox1.SelectedIndex = 0;
            label1.Text = "Total Packets Allowed: " + model.getTotalPass();
            label2.Text = "Total Packets Blocked: " + model.getTotalBlock();
            label3.Text = "Between " + model.getStartTime() + " and " + model.getEndTime();
        }




    }
}
